-- D42 RLE depacker V1.1

strUsage = [[
Usage: lua d42_unpack_room.lua <inputfile> <outputfile>
]]

function _G.printf(...) print(string.format(...)) end

function depackD4(bin)
	local pos = 0
	local function getbyte() 
		pos = pos + 1
		return bin:byte(pos)
	end
	
	local unpacked = {}
	local function putbyte(b)
		table.insert(unpacked, string.char(b))
	end
	
	putbyte(getbyte()) -- copy load addr
	putbyte(getbyte())
	
	local packbyte = getbyte()
	
	while (pos<bin:len()) do
		local b = getbyte()
		if b == packbyte then
			local count = getbyte()
			b = getbyte()
			if count== 0 then break end
			for i=1,count do putbyte(b) end
		else
			putbyte(b)
		end
	end

	if #unpacked < 0x1f02 then
		printf("unpacked room file is too short: 0x%x", #unpacked)
	elseif #unpacked > 0x2002 then
		printf("unpacked room file exceeds area: 0x%x", #unpacked)
	end
		
	if pos < bin:len() then
		printf("depackD4: End marker before EOF: pos = 0x%x, packed len = 0x%x, unpacked len = 0x%x",
		pos, bin:len(), #unpacked)
	end
	
	local unpacked_bin = table.concat(unpacked)
	local unpacked_len = unpacked_bin:len()
	local default_len = 0x1f02
	
	if unpacked_len < default_len then	
		printf("depackD4: unpacked file is too short ($%04x bytes)", unpacked_len)
		error()
	elseif unpacked_len > default_len then
		printf("depackD4: unpacked file is too long ($%04x), truncating ", unpacked_len)
		unpacked_bin = unpacked_bin:sub(1, default_len)
	end
	return unpacked_bin
end

if #arg ~= 2 then
	print(strUsage) 
	os.exit(0)
else
	strInputFile = arg[1]
	strOutputFile = arg[2]
	
	fd, msg = io.open(strInputFile, "rb")
	assert(fd, msg)
	bin = fd:read("*a")
	fd:close()
	assert(bin, "erroro reading file")
	
	bin_unp = depackD4(bin)
	
	fd, msg = io.open(strOutputFile, "wb")
	assert(fd, msg)
	fd:write(bin_unp)
	fd:close()
end